-- LPDDR2x32_s0.vhd

-- This file was auto-generated from qsys_sequencer_110_hw.tcl.  If you edit it your changes
-- will probably be lost.
-- 
-- Generated using ACDS version 14.0 200 at 2014.09.06.12:58:04

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity LPDDR2x32_s0 is
	port (
		avl_clk                 : in  std_logic                     := '0';             --          avl_clk.clk
		avl_reset_n             : in  std_logic                     := '0';             --    sequencer_rst.reset
		avl_address             : out std_logic_vector(15 downto 0);                    --              avl.address
		avl_read                : out std_logic;                                        --                 .read
		avl_readdata            : in  std_logic_vector(31 downto 0) := (others => '0'); --                 .readdata
		avl_write               : out std_logic;                                        --                 .write
		avl_writedata           : out std_logic_vector(31 downto 0);                    --                 .writedata
		avl_waitrequest         : in  std_logic                     := '0';             --                 .waitrequest
		scc_data                : out std_logic_vector(0 downto 0);                     --              scc.scc_data
		scc_dqs_ena             : out std_logic_vector(3 downto 0);                     --                 .scc_dqs_ena
		scc_dqs_io_ena          : out std_logic_vector(3 downto 0);                     --                 .scc_dqs_io_ena
		scc_dq_ena              : out std_logic_vector(31 downto 0);                    --                 .scc_dq_ena
		scc_dm_ena              : out std_logic_vector(3 downto 0);                     --                 .scc_dm_ena
		capture_strobe_tracking : in  std_logic_vector(3 downto 0)  := (others => '0'); --                 .capture_strobe_tracking
		scc_upd                 : out std_logic_vector(0 downto 0);                     --                 .scc_upd
		afi_init_req            : in  std_logic                     := '0';             -- afi_init_cal_req.afi_init_req
		afi_cal_req             : in  std_logic                     := '0';             --                 .afi_cal_req
		scc_clk                 : in  std_logic                     := '0';             --          scc_clk.clk
		reset_n_scc_clk         : in  std_logic                     := '0';             --        scc_reset.reset_n
		afi_seq_busy            : out std_logic_vector(0 downto 0);                     --          trk_afi.afi_seq_busy
		afi_ctl_long_idle       : in  std_logic_vector(0 downto 0)  := (others => '0'); --                 .afi_ctl_long_idle
		afi_ctl_refresh_done    : in  std_logic_vector(0 downto 0)  := (others => '0'); --                 .afi_ctl_refresh_done
		seq_waitrequest         : out std_logic;                                        --        seq_debug.waitrequest
		seq_readdata            : out std_logic_vector(31 downto 0);                    --                 .readdata
		seq_readdatavalid       : out std_logic;                                        --                 .readdatavalid
		seq_burstcount          : in  std_logic_vector(0 downto 0)  := (others => '0'); --                 .burstcount
		seq_writedata           : in  std_logic_vector(31 downto 0) := (others => '0'); --                 .writedata
		seq_address             : in  std_logic_vector(31 downto 0) := (others => '0'); --                 .address
		seq_write               : in  std_logic                     := '0';             --                 .write
		seq_read                : in  std_logic                     := '0';             --                 .read
		seq_byteenable          : in  std_logic_vector(3 downto 0)  := (others => '0'); --                 .byteenable
		seq_debugaccess         : in  std_logic                     := '0'              --                 .debugaccess
	);
end entity LPDDR2x32_s0;

architecture rtl of LPDDR2x32_s0 is
	component altera_mem_if_sequencer_rst is
		generic (
			DEPTH            : integer := 8;
			CLKEN_LAGS_RESET : integer := 0
		);
		port (
			clk       : in  std_logic := 'X'; -- clk
			rst       : in  std_logic := 'X'; -- reset
			reset_out : out std_logic;        -- reset
			clken_out : out std_logic         -- clken
		);
	end component altera_mem_if_sequencer_rst;

	component altera_mem_if_sequencer_cpu_cv_sim_cpu_inst is
		generic (
			DEVICE_FAMILY : string := "STRATIXIV"
		);
		port (
			clk           : in  std_logic                     := 'X';             -- clk
			reset_n       : in  std_logic                     := 'X';             -- reset_n
			d_address     : out std_logic_vector(19 downto 0);                    -- address
			d_byteenable  : out std_logic_vector(3 downto 0);                     -- byteenable
			d_read        : out std_logic;                                        -- read
			d_readdata    : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			d_waitrequest : in  std_logic                     := 'X';             -- waitrequest
			d_write       : out std_logic;                                        -- write
			d_writedata   : out std_logic_vector(31 downto 0);                    -- writedata
			i_address     : out std_logic_vector(16 downto 0);                    -- address
			i_read        : out std_logic;                                        -- read
			i_readdata    : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			i_waitrequest : in  std_logic                     := 'X';             -- waitrequest
			d_irq         : in  std_logic_vector(31 downto 0) := (others => 'X'); -- irq
			no_ci_readra  : out std_logic                                         -- readra
		);
	end component altera_mem_if_sequencer_cpu_cv_sim_cpu_inst;

	component sequencer_scc_mgr is
		generic (
			AVL_DATA_WIDTH         : integer := 32;
			AVL_ADDR_WIDTH         : integer := 13;
			MEM_IF_READ_DQS_WIDTH  : integer := 8;
			MEM_IF_WRITE_DQS_WIDTH : integer := 8;
			MEM_IF_DQ_WIDTH        : integer := 64;
			MEM_IF_DM_WIDTH        : integer := 8;
			MEM_NUMBER_OF_RANKS    : integer := 1;
			DLL_DELAY_CHAIN_LENGTH : integer := 6;
			FAMILY                 : string  := "STRATIXIII";
			USE_2X_DLL             : string  := "false";
			USE_SHADOW_REGS        : boolean := false;
			USE_DQS_TRACKING       : integer := 0;
			DUAL_WRITE_CLOCK       : integer := 0;
			SCC_DATA_WIDTH         : integer := 8;
			TRK_PARALLEL_SCC_LOAD  : boolean := false
		);
		port (
			avl_clk                      : in  std_logic                     := 'X';             -- clk
			avl_reset_n                  : in  std_logic                     := 'X';             -- reset_n
			avl_address                  : in  std_logic_vector(12 downto 0) := (others => 'X'); -- address
			avl_write                    : in  std_logic                     := 'X';             -- write
			avl_writedata                : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			avl_read                     : in  std_logic                     := 'X';             -- read
			avl_readdata                 : out std_logic_vector(31 downto 0);                    -- readdata
			avl_waitrequest              : out std_logic;                                        -- waitrequest
			scc_clk                      : in  std_logic                     := 'X';             -- clk
			scc_reset_n                  : in  std_logic                     := 'X';             -- reset_n
			scc_data                     : out std_logic_vector(0 downto 0);                     -- scc_data
			scc_dqs_ena                  : out std_logic_vector(3 downto 0);                     -- scc_dqs_ena
			scc_dqs_io_ena               : out std_logic_vector(3 downto 0);                     -- scc_dqs_io_ena
			scc_dq_ena                   : out std_logic_vector(31 downto 0);                    -- scc_dq_ena
			scc_dm_ena                   : out std_logic_vector(3 downto 0);                     -- scc_dm_ena
			capture_strobe_tracking      : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- capture_strobe_tracking
			scc_upd                      : out std_logic_vector(0 downto 0);                     -- scc_upd
			afi_init_req                 : in  std_logic                     := 'X';             -- afi_init_req
			afi_cal_req                  : in  std_logic                     := 'X';             -- afi_cal_req
			scc_sr_dqsenable_delayctrl   : out std_logic_vector(7 downto 0);                     -- scc_sr_dqsenable_delayctrl
			scc_sr_dqsdisablen_delayctrl : out std_logic_vector(7 downto 0);                     -- scc_sr_dqsdisablen_delayctrl
			scc_sr_multirank_delayctrl   : out std_logic_vector(7 downto 0)                      -- scc_sr_multirank_delayctrl
		);
	end component sequencer_scc_mgr;

	component sequencer_reg_file is
		generic (
			AVL_DATA_WIDTH    : integer := 32;
			AVL_ADDR_WIDTH    : integer := 13;
			AVL_NUM_SYMBOLS   : integer := 4;
			AVL_SYMBOL_WIDTH  : integer := 8;
			REGISTER_RDATA    : boolean := false;
			NUM_REGFILE_WORDS : integer := 8
		);
		port (
			avl_clk         : in  std_logic                     := 'X';             -- clk
			avl_reset_n     : in  std_logic                     := 'X';             -- reset_n
			avl_address     : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- address
			avl_write       : in  std_logic                     := 'X';             -- write
			avl_writedata   : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			avl_read        : in  std_logic                     := 'X';             -- read
			avl_readdata    : out std_logic_vector(31 downto 0);                    -- readdata
			avl_waitrequest : out std_logic;                                        -- waitrequest
			avl_be          : in  std_logic_vector(3 downto 0)  := (others => 'X')  -- byteenable
		);
	end component sequencer_reg_file;

	component LPDDR2x32_s0_trk_mm_bridge is
		port (
			clk              : in  std_logic                     := 'X';             -- clk
			reset            : in  std_logic                     := 'X';             -- reset
			s0_waitrequest   : out std_logic;                                        -- waitrequest
			s0_readdata      : out std_logic_vector(31 downto 0);                    -- readdata
			s0_readdatavalid : out std_logic;                                        -- readdatavalid
			s0_burstcount    : in  std_logic_vector(0 downto 0)  := (others => 'X'); -- burstcount
			s0_writedata     : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			s0_address       : in  std_logic_vector(15 downto 0) := (others => 'X'); -- address
			s0_write         : in  std_logic                     := 'X';             -- write
			s0_read          : in  std_logic                     := 'X';             -- read
			s0_byteenable    : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- byteenable
			s0_debugaccess   : in  std_logic                     := 'X';             -- debugaccess
			m0_waitrequest   : in  std_logic                     := 'X';             -- waitrequest
			m0_readdata      : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			m0_readdatavalid : in  std_logic                     := 'X';             -- readdatavalid
			m0_burstcount    : out std_logic_vector(0 downto 0);                     -- burstcount
			m0_writedata     : out std_logic_vector(31 downto 0);                    -- writedata
			m0_address       : out std_logic_vector(15 downto 0);                    -- address
			m0_write         : out std_logic;                                        -- write
			m0_read          : out std_logic;                                        -- read
			m0_byteenable    : out std_logic_vector(3 downto 0);                     -- byteenable
			m0_debugaccess   : out std_logic                                         -- debugaccess
		);
	end component LPDDR2x32_s0_trk_mm_bridge;

	component altera_mem_if_simple_avalon_mm_bridge is
		generic (
			DATA_WIDTH                : integer := 32;
			SLAVE_DATA_WIDTH          : integer := 32;
			MASTER_DATA_WIDTH         : integer := 32;
			SYMBOL_WIDTH              : integer := 8;
			ADDRESS_WIDTH             : integer := 10;
			MASTER_ADDRESS_WIDTH      : integer := 10;
			SLAVE_ADDRESS_WIDTH       : integer := 10;
			BURSTCOUNT_WIDTH          : integer := 3;
			WORKAROUND_HARD_PHY_ISSUE : integer := 0
		);
		port (
			clk                   : in  std_logic                     := 'X';             -- clk
			reset_n               : in  std_logic                     := 'X';             -- reset_n
			s0_address            : in  std_logic_vector(15 downto 0) := (others => 'X'); -- address
			s0_read               : in  std_logic                     := 'X';             -- read
			s0_readdata           : out std_logic_vector(31 downto 0);                    -- readdata
			s0_write              : in  std_logic                     := 'X';             -- write
			s0_writedata          : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			s0_waitrequest        : out std_logic;                                        -- waitrequest
			m0_address            : out std_logic_vector(15 downto 0);                    -- address
			m0_read               : out std_logic;                                        -- read
			m0_readdata           : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			m0_write              : out std_logic;                                        -- write
			m0_writedata          : out std_logic_vector(31 downto 0);                    -- writedata
			m0_waitrequest        : in  std_logic                     := 'X';             -- waitrequest
			s0_waitrequest_n      : out std_logic;                                        -- waitrequest_n
			s0_beginbursttransfer : in  std_logic                     := 'X';             -- beginbursttransfer
			s0_burstcount         : in  std_logic_vector(2 downto 0)  := (others => 'X'); -- burstcount
			s0_byteenable         : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- byteenable
			s0_readdatavalid      : out std_logic;                                        -- readdatavalid
			m0_beginbursttransfer : out std_logic;                                        -- beginbursttransfer
			m0_burstcount         : out std_logic_vector(2 downto 0);                     -- burstcount
			m0_byteenable         : out std_logic_vector(3 downto 0);                     -- byteenable
			m0_readdatavalid      : in  std_logic                     := 'X'              -- readdatavalid
		);
	end component altera_mem_if_simple_avalon_mm_bridge;

	component sequencer_trk_mgr is
		generic (
			MEM_CHIP_SELECT_WIDTH  : integer := 1;
			MEM_NUMBER_OF_RANKS    : integer := 1;
			AVL_DATA_WIDTH         : integer := 32;
			AVL_MTR_ADDR_WIDTH     : integer := 20;
			AVL_ADDR_WIDTH         : integer := 6;
			RATE                   : string  := "Half";
			MEM_READ_DQS_WIDTH     : integer := 8;
			PHASE_WIDTH            : integer := 3;
			READ_VALID_FIFO_SIZE   : integer := 4;
			MUX_SEL_SEQUENCER_VAL  : integer := 1;
			MUX_SEL_CONTROLLER_VAL : integer := 0;
			PHY_MGR_BASE           : integer := 0;
			RW_MGR_BASE            : integer := 0;
			SCC_MGR_BASE           : integer := 0;
			HARD_PHY               : boolean := false;
			HARD_VFIFO             : boolean := false;
			IO_DQS_EN_DELAY_OFFSET : integer := 0;
			TRK_PARALLEL_SCC_LOAD  : boolean := false
		);
		port (
			avl_clk              : in  std_logic                     := 'X';             -- clk
			avl_reset_n          : in  std_logic                     := 'X';             -- reset_n
			trkm_address         : out std_logic_vector(19 downto 0);                    -- address
			trkm_write           : out std_logic;                                        -- write
			trkm_writedata       : out std_logic_vector(31 downto 0);                    -- writedata
			trkm_read            : out std_logic;                                        -- read
			trkm_readdata        : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			trkm_waitrequest     : in  std_logic                     := 'X';             -- waitrequest
			trks_address         : in  std_logic_vector(5 downto 0)  := (others => 'X'); -- address
			trks_write           : in  std_logic                     := 'X';             -- write
			trks_writedata       : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			trks_read            : in  std_logic                     := 'X';             -- read
			trks_readdata        : out std_logic_vector(31 downto 0);                    -- readdata
			trks_waitrequest     : out std_logic;                                        -- waitrequest
			afi_seq_busy         : out std_logic_vector(0 downto 0);                     -- afi_seq_busy
			afi_ctl_long_idle    : in  std_logic_vector(0 downto 0)  := (others => 'X'); -- afi_ctl_long_idle
			afi_ctl_refresh_done : in  std_logic_vector(0 downto 0)  := (others => 'X')  -- afi_ctl_refresh_done
		);
	end component sequencer_trk_mgr;

	component altera_mem_if_sequencer_mem_no_ifdef_params is
		generic (
			AVL_DATA_WIDTH   : integer := 32;
			AVL_ADDR_WIDTH   : integer := 13;
			AVL_NUM_SYMBOLS  : integer := 4;
			AVL_SYMBOL_WIDTH : integer := 8;
			MEM_SIZE         : integer := 1024;
			INIT_FILE        : string  := "";
			RAM_BLOCK_TYPE   : string  := "AUTO"
		);
		port (
			clk1          : in  std_logic                     := 'X';             -- clk
			reset1        : in  std_logic                     := 'X';             -- reset
			clken1        : in  std_logic                     := 'X';             -- clken
			s1_address    : in  std_logic_vector(11 downto 0) := (others => 'X'); -- address
			s1_write      : in  std_logic                     := 'X';             -- write
			s1_writedata  : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			s1_readdata   : out std_logic_vector(31 downto 0);                    -- readdata
			s1_be         : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- byteenable
			s1_chipselect : in  std_logic                     := 'X'              -- chipselect
		);
	end component altera_mem_if_sequencer_mem_no_ifdef_params;

	component LPDDR2x32_s0_seq_bridge is
		port (
			clk              : in  std_logic                     := 'X';             -- clk
			reset            : in  std_logic                     := 'X';             -- reset
			s0_waitrequest   : out std_logic;                                        -- waitrequest
			s0_readdata      : out std_logic_vector(31 downto 0);                    -- readdata
			s0_readdatavalid : out std_logic;                                        -- readdatavalid
			s0_burstcount    : in  std_logic_vector(0 downto 0)  := (others => 'X'); -- burstcount
			s0_writedata     : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			s0_address       : in  std_logic_vector(31 downto 0) := (others => 'X'); -- address
			s0_write         : in  std_logic                     := 'X';             -- write
			s0_read          : in  std_logic                     := 'X';             -- read
			s0_byteenable    : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- byteenable
			s0_debugaccess   : in  std_logic                     := 'X';             -- debugaccess
			m0_waitrequest   : in  std_logic                     := 'X';             -- waitrequest
			m0_readdata      : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			m0_readdatavalid : in  std_logic                     := 'X';             -- readdatavalid
			m0_burstcount    : out std_logic_vector(0 downto 0);                     -- burstcount
			m0_writedata     : out std_logic_vector(31 downto 0);                    -- writedata
			m0_address       : out std_logic_vector(31 downto 0);                    -- address
			m0_write         : out std_logic;                                        -- write
			m0_read          : out std_logic;                                        -- read
			m0_byteenable    : out std_logic_vector(3 downto 0);                     -- byteenable
			m0_debugaccess   : out std_logic                                         -- debugaccess
		);
	end component LPDDR2x32_s0_seq_bridge;

	component LPDDR2x32_s0_mm_interconnect_0 is
		port (
			avl_clk_out_clk_clk                                          : in  std_logic                     := 'X';             -- clk
			cpu_inst_reset_n_reset_bridge_in_reset_reset                 : in  std_logic                     := 'X';             -- reset
			sequencer_trk_mgr_inst_avl_reset_reset_bridge_in_reset_reset : in  std_logic                     := 'X';             -- reset
			cpu_inst_data_master_address                                 : in  std_logic_vector(19 downto 0) := (others => 'X'); -- address
			cpu_inst_data_master_waitrequest                             : out std_logic;                                        -- waitrequest
			cpu_inst_data_master_byteenable                              : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- byteenable
			cpu_inst_data_master_read                                    : in  std_logic                     := 'X';             -- read
			cpu_inst_data_master_readdata                                : out std_logic_vector(31 downto 0);                    -- readdata
			cpu_inst_data_master_write                                   : in  std_logic                     := 'X';             -- write
			cpu_inst_data_master_writedata                               : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			cpu_inst_instruction_master_address                          : in  std_logic_vector(16 downto 0) := (others => 'X'); -- address
			cpu_inst_instruction_master_waitrequest                      : out std_logic;                                        -- waitrequest
			cpu_inst_instruction_master_read                             : in  std_logic                     := 'X';             -- read
			cpu_inst_instruction_master_readdata                         : out std_logic_vector(31 downto 0);                    -- readdata
			seq_bridge_m0_address                                        : in  std_logic_vector(31 downto 0) := (others => 'X'); -- address
			seq_bridge_m0_waitrequest                                    : out std_logic;                                        -- waitrequest
			seq_bridge_m0_burstcount                                     : in  std_logic_vector(0 downto 0)  := (others => 'X'); -- burstcount
			seq_bridge_m0_byteenable                                     : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- byteenable
			seq_bridge_m0_read                                           : in  std_logic                     := 'X';             -- read
			seq_bridge_m0_readdata                                       : out std_logic_vector(31 downto 0);                    -- readdata
			seq_bridge_m0_readdatavalid                                  : out std_logic;                                        -- readdatavalid
			seq_bridge_m0_write                                          : in  std_logic                     := 'X';             -- write
			seq_bridge_m0_writedata                                      : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			seq_bridge_m0_debugaccess                                    : in  std_logic                     := 'X';             -- debugaccess
			sequencer_trk_mgr_inst_trkm_address                          : in  std_logic_vector(19 downto 0) := (others => 'X'); -- address
			sequencer_trk_mgr_inst_trkm_waitrequest                      : out std_logic;                                        -- waitrequest
			sequencer_trk_mgr_inst_trkm_read                             : in  std_logic                     := 'X';             -- read
			sequencer_trk_mgr_inst_trkm_readdata                         : out std_logic_vector(31 downto 0);                    -- readdata
			sequencer_trk_mgr_inst_trkm_write                            : in  std_logic                     := 'X';             -- write
			sequencer_trk_mgr_inst_trkm_writedata                        : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			trk_mm_bridge_m0_address                                     : in  std_logic_vector(15 downto 0) := (others => 'X'); -- address
			trk_mm_bridge_m0_waitrequest                                 : out std_logic;                                        -- waitrequest
			trk_mm_bridge_m0_burstcount                                  : in  std_logic_vector(0 downto 0)  := (others => 'X'); -- burstcount
			trk_mm_bridge_m0_byteenable                                  : in  std_logic_vector(3 downto 0)  := (others => 'X'); -- byteenable
			trk_mm_bridge_m0_read                                        : in  std_logic                     := 'X';             -- read
			trk_mm_bridge_m0_readdata                                    : out std_logic_vector(31 downto 0);                    -- readdata
			trk_mm_bridge_m0_readdatavalid                               : out std_logic;                                        -- readdatavalid
			trk_mm_bridge_m0_write                                       : in  std_logic                     := 'X';             -- write
			trk_mm_bridge_m0_writedata                                   : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			trk_mm_bridge_m0_debugaccess                                 : in  std_logic                     := 'X';             -- debugaccess
			hphy_bridge_s0_address                                       : out std_logic_vector(15 downto 0);                    -- address
			hphy_bridge_s0_write                                         : out std_logic;                                        -- write
			hphy_bridge_s0_read                                          : out std_logic;                                        -- read
			hphy_bridge_s0_readdata                                      : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			hphy_bridge_s0_writedata                                     : out std_logic_vector(31 downto 0);                    -- writedata
			hphy_bridge_s0_waitrequest                                   : in  std_logic                     := 'X';             -- waitrequest
			sequencer_mem_s1_address                                     : out std_logic_vector(11 downto 0);                    -- address
			sequencer_mem_s1_write                                       : out std_logic;                                        -- write
			sequencer_mem_s1_readdata                                    : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			sequencer_mem_s1_writedata                                   : out std_logic_vector(31 downto 0);                    -- writedata
			sequencer_mem_s1_byteenable                                  : out std_logic_vector(3 downto 0);                     -- byteenable
			sequencer_mem_s1_chipselect                                  : out std_logic;                                        -- chipselect
			sequencer_reg_file_inst_avl_address                          : out std_logic_vector(3 downto 0);                     -- address
			sequencer_reg_file_inst_avl_write                            : out std_logic;                                        -- write
			sequencer_reg_file_inst_avl_read                             : out std_logic;                                        -- read
			sequencer_reg_file_inst_avl_readdata                         : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			sequencer_reg_file_inst_avl_writedata                        : out std_logic_vector(31 downto 0);                    -- writedata
			sequencer_reg_file_inst_avl_byteenable                       : out std_logic_vector(3 downto 0);                     -- byteenable
			sequencer_reg_file_inst_avl_waitrequest                      : in  std_logic                     := 'X';             -- waitrequest
			sequencer_scc_mgr_inst_avl_address                           : out std_logic_vector(12 downto 0);                    -- address
			sequencer_scc_mgr_inst_avl_write                             : out std_logic;                                        -- write
			sequencer_scc_mgr_inst_avl_read                              : out std_logic;                                        -- read
			sequencer_scc_mgr_inst_avl_readdata                          : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			sequencer_scc_mgr_inst_avl_writedata                         : out std_logic_vector(31 downto 0);                    -- writedata
			sequencer_scc_mgr_inst_avl_waitrequest                       : in  std_logic                     := 'X';             -- waitrequest
			sequencer_trk_mgr_inst_trks_address                          : out std_logic_vector(5 downto 0);                     -- address
			sequencer_trk_mgr_inst_trks_write                            : out std_logic;                                        -- write
			sequencer_trk_mgr_inst_trks_read                             : out std_logic;                                        -- read
			sequencer_trk_mgr_inst_trks_readdata                         : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			sequencer_trk_mgr_inst_trks_writedata                        : out std_logic_vector(31 downto 0);                    -- writedata
			sequencer_trk_mgr_inst_trks_waitrequest                      : in  std_logic                     := 'X';             -- waitrequest
			trk_mm_bridge_s0_address                                     : out std_logic_vector(15 downto 0);                    -- address
			trk_mm_bridge_s0_write                                       : out std_logic;                                        -- write
			trk_mm_bridge_s0_read                                        : out std_logic;                                        -- read
			trk_mm_bridge_s0_readdata                                    : in  std_logic_vector(31 downto 0) := (others => 'X'); -- readdata
			trk_mm_bridge_s0_writedata                                   : out std_logic_vector(31 downto 0);                    -- writedata
			trk_mm_bridge_s0_burstcount                                  : out std_logic_vector(0 downto 0);                     -- burstcount
			trk_mm_bridge_s0_byteenable                                  : out std_logic_vector(3 downto 0);                     -- byteenable
			trk_mm_bridge_s0_readdatavalid                               : in  std_logic                     := 'X';             -- readdatavalid
			trk_mm_bridge_s0_waitrequest                                 : in  std_logic                     := 'X';             -- waitrequest
			trk_mm_bridge_s0_debugaccess                                 : out std_logic                                         -- debugaccess
		);
	end component LPDDR2x32_s0_mm_interconnect_0;

	component LPDDR2x32_s0_irq_mapper is
		port (
			clk        : in  std_logic                     := 'X'; -- clk
			reset      : in  std_logic                     := 'X'; -- reset
			sender_irq : out std_logic_vector(31 downto 0)         -- irq
		);
	end component LPDDR2x32_s0_irq_mapper;

	signal sequencer_rst_reset_out_reset                             : std_logic;                     -- sequencer_rst:reset_out -> [irq_mapper:reset, mm_interconnect_0:cpu_inst_reset_n_reset_bridge_in_reset_reset, mm_interconnect_0:sequencer_trk_mgr_inst_avl_reset_reset_bridge_in_reset_reset, seq_bridge:reset, sequencer_mem:reset1, sequencer_rst_reset_out_reset:in, trk_mm_bridge:reset]
	signal sequencer_rst_clken_out_clken                             : std_logic;                     -- sequencer_rst:clken_out -> sequencer_mem:clken1
	signal cpu_inst_data_master_waitrequest                          : std_logic;                     -- mm_interconnect_0:cpu_inst_data_master_waitrequest -> cpu_inst:d_waitrequest
	signal cpu_inst_data_master_writedata                            : std_logic_vector(31 downto 0); -- cpu_inst:d_writedata -> mm_interconnect_0:cpu_inst_data_master_writedata
	signal cpu_inst_data_master_address                              : std_logic_vector(19 downto 0); -- cpu_inst:d_address -> mm_interconnect_0:cpu_inst_data_master_address
	signal cpu_inst_data_master_write                                : std_logic;                     -- cpu_inst:d_write -> mm_interconnect_0:cpu_inst_data_master_write
	signal cpu_inst_data_master_read                                 : std_logic;                     -- cpu_inst:d_read -> mm_interconnect_0:cpu_inst_data_master_read
	signal cpu_inst_data_master_readdata                             : std_logic_vector(31 downto 0); -- mm_interconnect_0:cpu_inst_data_master_readdata -> cpu_inst:d_readdata
	signal cpu_inst_data_master_byteenable                           : std_logic_vector(3 downto 0);  -- cpu_inst:d_byteenable -> mm_interconnect_0:cpu_inst_data_master_byteenable
	signal cpu_inst_instruction_master_waitrequest                   : std_logic;                     -- mm_interconnect_0:cpu_inst_instruction_master_waitrequest -> cpu_inst:i_waitrequest
	signal cpu_inst_instruction_master_address                       : std_logic_vector(16 downto 0); -- cpu_inst:i_address -> mm_interconnect_0:cpu_inst_instruction_master_address
	signal cpu_inst_instruction_master_read                          : std_logic;                     -- cpu_inst:i_read -> mm_interconnect_0:cpu_inst_instruction_master_read
	signal cpu_inst_instruction_master_readdata                      : std_logic_vector(31 downto 0); -- mm_interconnect_0:cpu_inst_instruction_master_readdata -> cpu_inst:i_readdata
	signal seq_bridge_m0_burstcount                                  : std_logic_vector(0 downto 0);  -- seq_bridge:m0_burstcount -> mm_interconnect_0:seq_bridge_m0_burstcount
	signal seq_bridge_m0_waitrequest                                 : std_logic;                     -- mm_interconnect_0:seq_bridge_m0_waitrequest -> seq_bridge:m0_waitrequest
	signal seq_bridge_m0_address                                     : std_logic_vector(31 downto 0); -- seq_bridge:m0_address -> mm_interconnect_0:seq_bridge_m0_address
	signal seq_bridge_m0_writedata                                   : std_logic_vector(31 downto 0); -- seq_bridge:m0_writedata -> mm_interconnect_0:seq_bridge_m0_writedata
	signal seq_bridge_m0_write                                       : std_logic;                     -- seq_bridge:m0_write -> mm_interconnect_0:seq_bridge_m0_write
	signal seq_bridge_m0_read                                        : std_logic;                     -- seq_bridge:m0_read -> mm_interconnect_0:seq_bridge_m0_read
	signal seq_bridge_m0_readdata                                    : std_logic_vector(31 downto 0); -- mm_interconnect_0:seq_bridge_m0_readdata -> seq_bridge:m0_readdata
	signal seq_bridge_m0_debugaccess                                 : std_logic;                     -- seq_bridge:m0_debugaccess -> mm_interconnect_0:seq_bridge_m0_debugaccess
	signal seq_bridge_m0_byteenable                                  : std_logic_vector(3 downto 0);  -- seq_bridge:m0_byteenable -> mm_interconnect_0:seq_bridge_m0_byteenable
	signal seq_bridge_m0_readdatavalid                               : std_logic;                     -- mm_interconnect_0:seq_bridge_m0_readdatavalid -> seq_bridge:m0_readdatavalid
	signal trk_mm_bridge_m0_burstcount                               : std_logic_vector(0 downto 0);  -- trk_mm_bridge:m0_burstcount -> mm_interconnect_0:trk_mm_bridge_m0_burstcount
	signal trk_mm_bridge_m0_waitrequest                              : std_logic;                     -- mm_interconnect_0:trk_mm_bridge_m0_waitrequest -> trk_mm_bridge:m0_waitrequest
	signal trk_mm_bridge_m0_address                                  : std_logic_vector(15 downto 0); -- trk_mm_bridge:m0_address -> mm_interconnect_0:trk_mm_bridge_m0_address
	signal trk_mm_bridge_m0_writedata                                : std_logic_vector(31 downto 0); -- trk_mm_bridge:m0_writedata -> mm_interconnect_0:trk_mm_bridge_m0_writedata
	signal trk_mm_bridge_m0_write                                    : std_logic;                     -- trk_mm_bridge:m0_write -> mm_interconnect_0:trk_mm_bridge_m0_write
	signal trk_mm_bridge_m0_read                                     : std_logic;                     -- trk_mm_bridge:m0_read -> mm_interconnect_0:trk_mm_bridge_m0_read
	signal trk_mm_bridge_m0_readdata                                 : std_logic_vector(31 downto 0); -- mm_interconnect_0:trk_mm_bridge_m0_readdata -> trk_mm_bridge:m0_readdata
	signal trk_mm_bridge_m0_debugaccess                              : std_logic;                     -- trk_mm_bridge:m0_debugaccess -> mm_interconnect_0:trk_mm_bridge_m0_debugaccess
	signal trk_mm_bridge_m0_byteenable                               : std_logic_vector(3 downto 0);  -- trk_mm_bridge:m0_byteenable -> mm_interconnect_0:trk_mm_bridge_m0_byteenable
	signal trk_mm_bridge_m0_readdatavalid                            : std_logic;                     -- mm_interconnect_0:trk_mm_bridge_m0_readdatavalid -> trk_mm_bridge:m0_readdatavalid
	signal sequencer_trk_mgr_inst_trkm_waitrequest                   : std_logic;                     -- mm_interconnect_0:sequencer_trk_mgr_inst_trkm_waitrequest -> sequencer_trk_mgr_inst:trkm_waitrequest
	signal sequencer_trk_mgr_inst_trkm_writedata                     : std_logic_vector(31 downto 0); -- sequencer_trk_mgr_inst:trkm_writedata -> mm_interconnect_0:sequencer_trk_mgr_inst_trkm_writedata
	signal sequencer_trk_mgr_inst_trkm_address                       : std_logic_vector(19 downto 0); -- sequencer_trk_mgr_inst:trkm_address -> mm_interconnect_0:sequencer_trk_mgr_inst_trkm_address
	signal sequencer_trk_mgr_inst_trkm_write                         : std_logic;                     -- sequencer_trk_mgr_inst:trkm_write -> mm_interconnect_0:sequencer_trk_mgr_inst_trkm_write
	signal sequencer_trk_mgr_inst_trkm_read                          : std_logic;                     -- sequencer_trk_mgr_inst:trkm_read -> mm_interconnect_0:sequencer_trk_mgr_inst_trkm_read
	signal sequencer_trk_mgr_inst_trkm_readdata                      : std_logic_vector(31 downto 0); -- mm_interconnect_0:sequencer_trk_mgr_inst_trkm_readdata -> sequencer_trk_mgr_inst:trkm_readdata
	signal mm_interconnect_0_trk_mm_bridge_s0_waitrequest            : std_logic;                     -- trk_mm_bridge:s0_waitrequest -> mm_interconnect_0:trk_mm_bridge_s0_waitrequest
	signal mm_interconnect_0_trk_mm_bridge_s0_burstcount             : std_logic_vector(0 downto 0);  -- mm_interconnect_0:trk_mm_bridge_s0_burstcount -> trk_mm_bridge:s0_burstcount
	signal mm_interconnect_0_trk_mm_bridge_s0_writedata              : std_logic_vector(31 downto 0); -- mm_interconnect_0:trk_mm_bridge_s0_writedata -> trk_mm_bridge:s0_writedata
	signal mm_interconnect_0_trk_mm_bridge_s0_address                : std_logic_vector(15 downto 0); -- mm_interconnect_0:trk_mm_bridge_s0_address -> trk_mm_bridge:s0_address
	signal mm_interconnect_0_trk_mm_bridge_s0_write                  : std_logic;                     -- mm_interconnect_0:trk_mm_bridge_s0_write -> trk_mm_bridge:s0_write
	signal mm_interconnect_0_trk_mm_bridge_s0_read                   : std_logic;                     -- mm_interconnect_0:trk_mm_bridge_s0_read -> trk_mm_bridge:s0_read
	signal mm_interconnect_0_trk_mm_bridge_s0_readdata               : std_logic_vector(31 downto 0); -- trk_mm_bridge:s0_readdata -> mm_interconnect_0:trk_mm_bridge_s0_readdata
	signal mm_interconnect_0_trk_mm_bridge_s0_debugaccess            : std_logic;                     -- mm_interconnect_0:trk_mm_bridge_s0_debugaccess -> trk_mm_bridge:s0_debugaccess
	signal mm_interconnect_0_trk_mm_bridge_s0_readdatavalid          : std_logic;                     -- trk_mm_bridge:s0_readdatavalid -> mm_interconnect_0:trk_mm_bridge_s0_readdatavalid
	signal mm_interconnect_0_trk_mm_bridge_s0_byteenable             : std_logic_vector(3 downto 0);  -- mm_interconnect_0:trk_mm_bridge_s0_byteenable -> trk_mm_bridge:s0_byteenable
	signal mm_interconnect_0_hphy_bridge_s0_waitrequest              : std_logic;                     -- hphy_bridge:s0_waitrequest -> mm_interconnect_0:hphy_bridge_s0_waitrequest
	signal mm_interconnect_0_hphy_bridge_s0_writedata                : std_logic_vector(31 downto 0); -- mm_interconnect_0:hphy_bridge_s0_writedata -> hphy_bridge:s0_writedata
	signal mm_interconnect_0_hphy_bridge_s0_address                  : std_logic_vector(15 downto 0); -- mm_interconnect_0:hphy_bridge_s0_address -> hphy_bridge:s0_address
	signal mm_interconnect_0_hphy_bridge_s0_write                    : std_logic;                     -- mm_interconnect_0:hphy_bridge_s0_write -> hphy_bridge:s0_write
	signal mm_interconnect_0_hphy_bridge_s0_read                     : std_logic;                     -- mm_interconnect_0:hphy_bridge_s0_read -> hphy_bridge:s0_read
	signal mm_interconnect_0_hphy_bridge_s0_readdata                 : std_logic_vector(31 downto 0); -- hphy_bridge:s0_readdata -> mm_interconnect_0:hphy_bridge_s0_readdata
	signal mm_interconnect_0_sequencer_mem_s1_writedata              : std_logic_vector(31 downto 0); -- mm_interconnect_0:sequencer_mem_s1_writedata -> sequencer_mem:s1_writedata
	signal mm_interconnect_0_sequencer_mem_s1_address                : std_logic_vector(11 downto 0); -- mm_interconnect_0:sequencer_mem_s1_address -> sequencer_mem:s1_address
	signal mm_interconnect_0_sequencer_mem_s1_chipselect             : std_logic;                     -- mm_interconnect_0:sequencer_mem_s1_chipselect -> sequencer_mem:s1_chipselect
	signal mm_interconnect_0_sequencer_mem_s1_write                  : std_logic;                     -- mm_interconnect_0:sequencer_mem_s1_write -> sequencer_mem:s1_write
	signal mm_interconnect_0_sequencer_mem_s1_readdata               : std_logic_vector(31 downto 0); -- sequencer_mem:s1_readdata -> mm_interconnect_0:sequencer_mem_s1_readdata
	signal mm_interconnect_0_sequencer_mem_s1_byteenable             : std_logic_vector(3 downto 0);  -- mm_interconnect_0:sequencer_mem_s1_byteenable -> sequencer_mem:s1_be
	signal mm_interconnect_0_sequencer_trk_mgr_inst_trks_waitrequest : std_logic;                     -- sequencer_trk_mgr_inst:trks_waitrequest -> mm_interconnect_0:sequencer_trk_mgr_inst_trks_waitrequest
	signal mm_interconnect_0_sequencer_trk_mgr_inst_trks_writedata   : std_logic_vector(31 downto 0); -- mm_interconnect_0:sequencer_trk_mgr_inst_trks_writedata -> sequencer_trk_mgr_inst:trks_writedata
	signal mm_interconnect_0_sequencer_trk_mgr_inst_trks_address     : std_logic_vector(5 downto 0);  -- mm_interconnect_0:sequencer_trk_mgr_inst_trks_address -> sequencer_trk_mgr_inst:trks_address
	signal mm_interconnect_0_sequencer_trk_mgr_inst_trks_write       : std_logic;                     -- mm_interconnect_0:sequencer_trk_mgr_inst_trks_write -> sequencer_trk_mgr_inst:trks_write
	signal mm_interconnect_0_sequencer_trk_mgr_inst_trks_read        : std_logic;                     -- mm_interconnect_0:sequencer_trk_mgr_inst_trks_read -> sequencer_trk_mgr_inst:trks_read
	signal mm_interconnect_0_sequencer_trk_mgr_inst_trks_readdata    : std_logic_vector(31 downto 0); -- sequencer_trk_mgr_inst:trks_readdata -> mm_interconnect_0:sequencer_trk_mgr_inst_trks_readdata
	signal mm_interconnect_0_sequencer_reg_file_inst_avl_waitrequest : std_logic;                     -- sequencer_reg_file_inst:avl_waitrequest -> mm_interconnect_0:sequencer_reg_file_inst_avl_waitrequest
	signal mm_interconnect_0_sequencer_reg_file_inst_avl_writedata   : std_logic_vector(31 downto 0); -- mm_interconnect_0:sequencer_reg_file_inst_avl_writedata -> sequencer_reg_file_inst:avl_writedata
	signal mm_interconnect_0_sequencer_reg_file_inst_avl_address     : std_logic_vector(3 downto 0);  -- mm_interconnect_0:sequencer_reg_file_inst_avl_address -> sequencer_reg_file_inst:avl_address
	signal mm_interconnect_0_sequencer_reg_file_inst_avl_write       : std_logic;                     -- mm_interconnect_0:sequencer_reg_file_inst_avl_write -> sequencer_reg_file_inst:avl_write
	signal mm_interconnect_0_sequencer_reg_file_inst_avl_read        : std_logic;                     -- mm_interconnect_0:sequencer_reg_file_inst_avl_read -> sequencer_reg_file_inst:avl_read
	signal mm_interconnect_0_sequencer_reg_file_inst_avl_readdata    : std_logic_vector(31 downto 0); -- sequencer_reg_file_inst:avl_readdata -> mm_interconnect_0:sequencer_reg_file_inst_avl_readdata
	signal mm_interconnect_0_sequencer_reg_file_inst_avl_byteenable  : std_logic_vector(3 downto 0);  -- mm_interconnect_0:sequencer_reg_file_inst_avl_byteenable -> sequencer_reg_file_inst:avl_be
	signal mm_interconnect_0_sequencer_scc_mgr_inst_avl_waitrequest  : std_logic;                     -- sequencer_scc_mgr_inst:avl_waitrequest -> mm_interconnect_0:sequencer_scc_mgr_inst_avl_waitrequest
	signal mm_interconnect_0_sequencer_scc_mgr_inst_avl_writedata    : std_logic_vector(31 downto 0); -- mm_interconnect_0:sequencer_scc_mgr_inst_avl_writedata -> sequencer_scc_mgr_inst:avl_writedata
	signal mm_interconnect_0_sequencer_scc_mgr_inst_avl_address      : std_logic_vector(12 downto 0); -- mm_interconnect_0:sequencer_scc_mgr_inst_avl_address -> sequencer_scc_mgr_inst:avl_address
	signal mm_interconnect_0_sequencer_scc_mgr_inst_avl_write        : std_logic;                     -- mm_interconnect_0:sequencer_scc_mgr_inst_avl_write -> sequencer_scc_mgr_inst:avl_write
	signal mm_interconnect_0_sequencer_scc_mgr_inst_avl_read         : std_logic;                     -- mm_interconnect_0:sequencer_scc_mgr_inst_avl_read -> sequencer_scc_mgr_inst:avl_read
	signal mm_interconnect_0_sequencer_scc_mgr_inst_avl_readdata     : std_logic_vector(31 downto 0); -- sequencer_scc_mgr_inst:avl_readdata -> mm_interconnect_0:sequencer_scc_mgr_inst_avl_readdata
	signal cpu_inst_d_irq_irq                                        : std_logic_vector(31 downto 0); -- irq_mapper:sender_irq -> cpu_inst:d_irq
	signal sequencer_rst_reset_out_reset_ports_inv                   : std_logic;                     -- sequencer_rst_reset_out_reset:inv -> [cpu_inst:reset_n, hphy_bridge:reset_n, sequencer_reg_file_inst:avl_reset_n, sequencer_scc_mgr_inst:avl_reset_n, sequencer_trk_mgr_inst:avl_reset_n]

begin

	sequencer_rst : component altera_mem_if_sequencer_rst
		generic map (
			DEPTH            => 10,
			CLKEN_LAGS_RESET => 0
		)
		port map (
			clk       => avl_clk,                       --       clk.clk
			rst       => avl_reset_n,                   --       rst.reset
			reset_out => sequencer_rst_reset_out_reset, -- reset_out.reset
			clken_out => sequencer_rst_clken_out_clken  -- clken_out.clken
		);

	cpu_inst : component altera_mem_if_sequencer_cpu_cv_sim_cpu_inst
		generic map (
			DEVICE_FAMILY => "CYCLONEV"
		)
		port map (
			clk           => avl_clk,                                 --                       clk.clk
			reset_n       => sequencer_rst_reset_out_reset_ports_inv, --                   reset_n.reset_n
			d_address     => cpu_inst_data_master_address,            --               data_master.address
			d_byteenable  => cpu_inst_data_master_byteenable,         --                          .byteenable
			d_read        => cpu_inst_data_master_read,               --                          .read
			d_readdata    => cpu_inst_data_master_readdata,           --                          .readdata
			d_waitrequest => cpu_inst_data_master_waitrequest,        --                          .waitrequest
			d_write       => cpu_inst_data_master_write,              --                          .write
			d_writedata   => cpu_inst_data_master_writedata,          --                          .writedata
			i_address     => cpu_inst_instruction_master_address,     --        instruction_master.address
			i_read        => cpu_inst_instruction_master_read,        --                          .read
			i_readdata    => cpu_inst_instruction_master_readdata,    --                          .readdata
			i_waitrequest => cpu_inst_instruction_master_waitrequest, --                          .waitrequest
			d_irq         => cpu_inst_d_irq_irq,                      --                     d_irq.irq
			no_ci_readra  => open                                     -- custom_instruction_master.readra
		);

	sequencer_scc_mgr_inst : component sequencer_scc_mgr
		generic map (
			AVL_DATA_WIDTH         => 32,
			AVL_ADDR_WIDTH         => 13,
			MEM_IF_READ_DQS_WIDTH  => 4,
			MEM_IF_WRITE_DQS_WIDTH => 4,
			MEM_IF_DQ_WIDTH        => 32,
			MEM_IF_DM_WIDTH        => 4,
			MEM_NUMBER_OF_RANKS    => 1,
			DLL_DELAY_CHAIN_LENGTH => 8,
			FAMILY                 => "CYCLONEV",
			USE_2X_DLL             => "false",
			USE_SHADOW_REGS        => false,
			USE_DQS_TRACKING       => 1,
			DUAL_WRITE_CLOCK       => 0,
			SCC_DATA_WIDTH         => 1,
			TRK_PARALLEL_SCC_LOAD  => false
		)
		port map (
			avl_clk                      => avl_clk,                                                  --          avl_clk.clk
			avl_reset_n                  => sequencer_rst_reset_out_reset_ports_inv,                  --        avl_reset.reset_n
			avl_address                  => mm_interconnect_0_sequencer_scc_mgr_inst_avl_address,     --              avl.address
			avl_write                    => mm_interconnect_0_sequencer_scc_mgr_inst_avl_write,       --                 .write
			avl_writedata                => mm_interconnect_0_sequencer_scc_mgr_inst_avl_writedata,   --                 .writedata
			avl_read                     => mm_interconnect_0_sequencer_scc_mgr_inst_avl_read,        --                 .read
			avl_readdata                 => mm_interconnect_0_sequencer_scc_mgr_inst_avl_readdata,    --                 .readdata
			avl_waitrequest              => mm_interconnect_0_sequencer_scc_mgr_inst_avl_waitrequest, --                 .waitrequest
			scc_clk                      => scc_clk,                                                  --          scc_clk.clk
			scc_reset_n                  => reset_n_scc_clk,                                          --        scc_reset.reset_n
			scc_data                     => scc_data,                                                 --              scc.scc_data
			scc_dqs_ena                  => scc_dqs_ena,                                              --                 .scc_dqs_ena
			scc_dqs_io_ena               => scc_dqs_io_ena,                                           --                 .scc_dqs_io_ena
			scc_dq_ena                   => scc_dq_ena,                                               --                 .scc_dq_ena
			scc_dm_ena                   => scc_dm_ena,                                               --                 .scc_dm_ena
			capture_strobe_tracking      => capture_strobe_tracking,                                  --                 .capture_strobe_tracking
			scc_upd                      => scc_upd,                                                  --                 .scc_upd
			afi_init_req                 => afi_init_req,                                             -- afi_init_cal_req.afi_init_req
			afi_cal_req                  => afi_cal_req,                                              --                 .afi_cal_req
			scc_sr_dqsenable_delayctrl   => open,                                                     --      (terminated)
			scc_sr_dqsdisablen_delayctrl => open,                                                     --      (terminated)
			scc_sr_multirank_delayctrl   => open                                                      --      (terminated)
		);

	sequencer_reg_file_inst : component sequencer_reg_file
		generic map (
			AVL_DATA_WIDTH    => 32,
			AVL_ADDR_WIDTH    => 4,
			AVL_NUM_SYMBOLS   => 4,
			AVL_SYMBOL_WIDTH  => 8,
			REGISTER_RDATA    => false,
			NUM_REGFILE_WORDS => 16
		)
		port map (
			avl_clk         => avl_clk,                                                   --   avl_clk.clk
			avl_reset_n     => sequencer_rst_reset_out_reset_ports_inv,                   -- avl_reset.reset_n
			avl_address     => mm_interconnect_0_sequencer_reg_file_inst_avl_address,     --       avl.address
			avl_write       => mm_interconnect_0_sequencer_reg_file_inst_avl_write,       --          .write
			avl_writedata   => mm_interconnect_0_sequencer_reg_file_inst_avl_writedata,   --          .writedata
			avl_read        => mm_interconnect_0_sequencer_reg_file_inst_avl_read,        --          .read
			avl_readdata    => mm_interconnect_0_sequencer_reg_file_inst_avl_readdata,    --          .readdata
			avl_waitrequest => mm_interconnect_0_sequencer_reg_file_inst_avl_waitrequest, --          .waitrequest
			avl_be          => mm_interconnect_0_sequencer_reg_file_inst_avl_byteenable   --          .byteenable
		);

	trk_mm_bridge : component LPDDR2x32_s0_trk_mm_bridge
		port map (
			clk              => avl_clk,                                          --   clk.clk
			reset            => sequencer_rst_reset_out_reset,                    -- reset.reset
			s0_waitrequest   => mm_interconnect_0_trk_mm_bridge_s0_waitrequest,   --    s0.waitrequest
			s0_readdata      => mm_interconnect_0_trk_mm_bridge_s0_readdata,      --      .readdata
			s0_readdatavalid => mm_interconnect_0_trk_mm_bridge_s0_readdatavalid, --      .readdatavalid
			s0_burstcount    => mm_interconnect_0_trk_mm_bridge_s0_burstcount,    --      .burstcount
			s0_writedata     => mm_interconnect_0_trk_mm_bridge_s0_writedata,     --      .writedata
			s0_address       => mm_interconnect_0_trk_mm_bridge_s0_address,       --      .address
			s0_write         => mm_interconnect_0_trk_mm_bridge_s0_write,         --      .write
			s0_read          => mm_interconnect_0_trk_mm_bridge_s0_read,          --      .read
			s0_byteenable    => mm_interconnect_0_trk_mm_bridge_s0_byteenable,    --      .byteenable
			s0_debugaccess   => mm_interconnect_0_trk_mm_bridge_s0_debugaccess,   --      .debugaccess
			m0_waitrequest   => trk_mm_bridge_m0_waitrequest,                     --    m0.waitrequest
			m0_readdata      => trk_mm_bridge_m0_readdata,                        --      .readdata
			m0_readdatavalid => trk_mm_bridge_m0_readdatavalid,                   --      .readdatavalid
			m0_burstcount    => trk_mm_bridge_m0_burstcount,                      --      .burstcount
			m0_writedata     => trk_mm_bridge_m0_writedata,                       --      .writedata
			m0_address       => trk_mm_bridge_m0_address,                         --      .address
			m0_write         => trk_mm_bridge_m0_write,                           --      .write
			m0_read          => trk_mm_bridge_m0_read,                            --      .read
			m0_byteenable    => trk_mm_bridge_m0_byteenable,                      --      .byteenable
			m0_debugaccess   => trk_mm_bridge_m0_debugaccess                      --      .debugaccess
		);

	hphy_bridge : component altera_mem_if_simple_avalon_mm_bridge
		generic map (
			DATA_WIDTH                => 32,
			SLAVE_DATA_WIDTH          => 32,
			MASTER_DATA_WIDTH         => 32,
			SYMBOL_WIDTH              => 8,
			ADDRESS_WIDTH             => 16,
			MASTER_ADDRESS_WIDTH      => 10,
			SLAVE_ADDRESS_WIDTH       => 10,
			BURSTCOUNT_WIDTH          => 3,
			WORKAROUND_HARD_PHY_ISSUE => 1
		)
		port map (
			clk                   => avl_clk,                                      --   clk.clk
			reset_n               => sequencer_rst_reset_out_reset_ports_inv,      -- reset.reset_n
			s0_address            => mm_interconnect_0_hphy_bridge_s0_address,     --    s0.address
			s0_read               => mm_interconnect_0_hphy_bridge_s0_read,        --      .read
			s0_readdata           => mm_interconnect_0_hphy_bridge_s0_readdata,    --      .readdata
			s0_write              => mm_interconnect_0_hphy_bridge_s0_write,       --      .write
			s0_writedata          => mm_interconnect_0_hphy_bridge_s0_writedata,   --      .writedata
			s0_waitrequest        => mm_interconnect_0_hphy_bridge_s0_waitrequest, --      .waitrequest
			m0_address            => avl_address,                                  --    m0.address
			m0_read               => avl_read,                                     --      .read
			m0_readdata           => avl_readdata,                                 --      .readdata
			m0_write              => avl_write,                                    --      .write
			m0_writedata          => avl_writedata,                                --      .writedata
			m0_waitrequest        => avl_waitrequest,                              --      .waitrequest
			s0_waitrequest_n      => open,                                         -- (terminated)
			s0_beginbursttransfer => '0',                                          -- (terminated)
			s0_burstcount         => "000",                                        -- (terminated)
			s0_byteenable         => "1111",                                       -- (terminated)
			s0_readdatavalid      => open,                                         -- (terminated)
			m0_beginbursttransfer => open,                                         -- (terminated)
			m0_burstcount         => open,                                         -- (terminated)
			m0_byteenable         => open,                                         -- (terminated)
			m0_readdatavalid      => '0'                                           -- (terminated)
		);

	sequencer_trk_mgr_inst : component sequencer_trk_mgr
		generic map (
			MEM_CHIP_SELECT_WIDTH  => 1,
			MEM_NUMBER_OF_RANKS    => 1,
			AVL_DATA_WIDTH         => 32,
			AVL_MTR_ADDR_WIDTH     => 20,
			AVL_ADDR_WIDTH         => 6,
			RATE                   => "Full",
			MEM_READ_DQS_WIDTH     => 4,
			PHASE_WIDTH            => 3,
			READ_VALID_FIFO_SIZE   => 16,
			MUX_SEL_SEQUENCER_VAL  => 3,
			MUX_SEL_CONTROLLER_VAL => 2,
			PHY_MGR_BASE           => 557056,
			RW_MGR_BASE            => 589824,
			SCC_MGR_BASE           => 98304,
			HARD_PHY               => true,
			HARD_VFIFO             => true,
			IO_DQS_EN_DELAY_OFFSET => 0,
			TRK_PARALLEL_SCC_LOAD  => false
		)
		port map (
			avl_clk              => avl_clk,                                                   --   avl_clk.clk
			avl_reset_n          => sequencer_rst_reset_out_reset_ports_inv,                   -- avl_reset.reset_n
			trkm_address         => sequencer_trk_mgr_inst_trkm_address,                       --      trkm.address
			trkm_write           => sequencer_trk_mgr_inst_trkm_write,                         --          .write
			trkm_writedata       => sequencer_trk_mgr_inst_trkm_writedata,                     --          .writedata
			trkm_read            => sequencer_trk_mgr_inst_trkm_read,                          --          .read
			trkm_readdata        => sequencer_trk_mgr_inst_trkm_readdata,                      --          .readdata
			trkm_waitrequest     => sequencer_trk_mgr_inst_trkm_waitrequest,                   --          .waitrequest
			trks_address         => mm_interconnect_0_sequencer_trk_mgr_inst_trks_address,     --      trks.address
			trks_write           => mm_interconnect_0_sequencer_trk_mgr_inst_trks_write,       --          .write
			trks_writedata       => mm_interconnect_0_sequencer_trk_mgr_inst_trks_writedata,   --          .writedata
			trks_read            => mm_interconnect_0_sequencer_trk_mgr_inst_trks_read,        --          .read
			trks_readdata        => mm_interconnect_0_sequencer_trk_mgr_inst_trks_readdata,    --          .readdata
			trks_waitrequest     => mm_interconnect_0_sequencer_trk_mgr_inst_trks_waitrequest, --          .waitrequest
			afi_seq_busy         => afi_seq_busy,                                              --       afi.afi_seq_busy
			afi_ctl_long_idle    => afi_ctl_long_idle,                                         --          .afi_ctl_long_idle
			afi_ctl_refresh_done => afi_ctl_refresh_done                                       --          .afi_ctl_refresh_done
		);

	sequencer_mem : component altera_mem_if_sequencer_mem_no_ifdef_params
		generic map (
			AVL_DATA_WIDTH   => 32,
			AVL_ADDR_WIDTH   => 12,
			AVL_NUM_SYMBOLS  => 4,
			AVL_SYMBOL_WIDTH => 8,
			MEM_SIZE         => 12288,
			INIT_FILE        => "LPDDR2x32_s0_sequencer_mem.hex",
			RAM_BLOCK_TYPE   => "AUTO"
		)
		port map (
			clk1          => avl_clk,                                       --   clk1.clk
			reset1        => sequencer_rst_reset_out_reset,                 -- reset1.reset
			clken1        => sequencer_rst_clken_out_clken,                 -- clken1.clken
			s1_address    => mm_interconnect_0_sequencer_mem_s1_address,    --     s1.address
			s1_write      => mm_interconnect_0_sequencer_mem_s1_write,      --       .write
			s1_writedata  => mm_interconnect_0_sequencer_mem_s1_writedata,  --       .writedata
			s1_readdata   => mm_interconnect_0_sequencer_mem_s1_readdata,   --       .readdata
			s1_be         => mm_interconnect_0_sequencer_mem_s1_byteenable, --       .byteenable
			s1_chipselect => mm_interconnect_0_sequencer_mem_s1_chipselect  --       .chipselect
		);

	seq_bridge : component LPDDR2x32_s0_seq_bridge
		port map (
			clk              => avl_clk,                       --   clk.clk
			reset            => sequencer_rst_reset_out_reset, -- reset.reset
			s0_waitrequest   => seq_waitrequest,               --    s0.waitrequest
			s0_readdata      => seq_readdata,                  --      .readdata
			s0_readdatavalid => seq_readdatavalid,             --      .readdatavalid
			s0_burstcount    => seq_burstcount,                --      .burstcount
			s0_writedata     => seq_writedata,                 --      .writedata
			s0_address       => seq_address,                   --      .address
			s0_write         => seq_write,                     --      .write
			s0_read          => seq_read,                      --      .read
			s0_byteenable    => seq_byteenable,                --      .byteenable
			s0_debugaccess   => seq_debugaccess,               --      .debugaccess
			m0_waitrequest   => seq_bridge_m0_waitrequest,     --    m0.waitrequest
			m0_readdata      => seq_bridge_m0_readdata,        --      .readdata
			m0_readdatavalid => seq_bridge_m0_readdatavalid,   --      .readdatavalid
			m0_burstcount    => seq_bridge_m0_burstcount,      --      .burstcount
			m0_writedata     => seq_bridge_m0_writedata,       --      .writedata
			m0_address       => seq_bridge_m0_address,         --      .address
			m0_write         => seq_bridge_m0_write,           --      .write
			m0_read          => seq_bridge_m0_read,            --      .read
			m0_byteenable    => seq_bridge_m0_byteenable,      --      .byteenable
			m0_debugaccess   => seq_bridge_m0_debugaccess      --      .debugaccess
		);

	mm_interconnect_0 : component LPDDR2x32_s0_mm_interconnect_0
		port map (
			avl_clk_out_clk_clk                                          => avl_clk,                                                   --                                        avl_clk_out_clk.clk
			cpu_inst_reset_n_reset_bridge_in_reset_reset                 => sequencer_rst_reset_out_reset,                             --                 cpu_inst_reset_n_reset_bridge_in_reset.reset
			sequencer_trk_mgr_inst_avl_reset_reset_bridge_in_reset_reset => sequencer_rst_reset_out_reset,                             -- sequencer_trk_mgr_inst_avl_reset_reset_bridge_in_reset.reset
			cpu_inst_data_master_address                                 => cpu_inst_data_master_address,                              --                                   cpu_inst_data_master.address
			cpu_inst_data_master_waitrequest                             => cpu_inst_data_master_waitrequest,                          --                                                       .waitrequest
			cpu_inst_data_master_byteenable                              => cpu_inst_data_master_byteenable,                           --                                                       .byteenable
			cpu_inst_data_master_read                                    => cpu_inst_data_master_read,                                 --                                                       .read
			cpu_inst_data_master_readdata                                => cpu_inst_data_master_readdata,                             --                                                       .readdata
			cpu_inst_data_master_write                                   => cpu_inst_data_master_write,                                --                                                       .write
			cpu_inst_data_master_writedata                               => cpu_inst_data_master_writedata,                            --                                                       .writedata
			cpu_inst_instruction_master_address                          => cpu_inst_instruction_master_address,                       --                            cpu_inst_instruction_master.address
			cpu_inst_instruction_master_waitrequest                      => cpu_inst_instruction_master_waitrequest,                   --                                                       .waitrequest
			cpu_inst_instruction_master_read                             => cpu_inst_instruction_master_read,                          --                                                       .read
			cpu_inst_instruction_master_readdata                         => cpu_inst_instruction_master_readdata,                      --                                                       .readdata
			seq_bridge_m0_address                                        => seq_bridge_m0_address,                                     --                                          seq_bridge_m0.address
			seq_bridge_m0_waitrequest                                    => seq_bridge_m0_waitrequest,                                 --                                                       .waitrequest
			seq_bridge_m0_burstcount                                     => seq_bridge_m0_burstcount,                                  --                                                       .burstcount
			seq_bridge_m0_byteenable                                     => seq_bridge_m0_byteenable,                                  --                                                       .byteenable
			seq_bridge_m0_read                                           => seq_bridge_m0_read,                                        --                                                       .read
			seq_bridge_m0_readdata                                       => seq_bridge_m0_readdata,                                    --                                                       .readdata
			seq_bridge_m0_readdatavalid                                  => seq_bridge_m0_readdatavalid,                               --                                                       .readdatavalid
			seq_bridge_m0_write                                          => seq_bridge_m0_write,                                       --                                                       .write
			seq_bridge_m0_writedata                                      => seq_bridge_m0_writedata,                                   --                                                       .writedata
			seq_bridge_m0_debugaccess                                    => seq_bridge_m0_debugaccess,                                 --                                                       .debugaccess
			sequencer_trk_mgr_inst_trkm_address                          => sequencer_trk_mgr_inst_trkm_address,                       --                            sequencer_trk_mgr_inst_trkm.address
			sequencer_trk_mgr_inst_trkm_waitrequest                      => sequencer_trk_mgr_inst_trkm_waitrequest,                   --                                                       .waitrequest
			sequencer_trk_mgr_inst_trkm_read                             => sequencer_trk_mgr_inst_trkm_read,                          --                                                       .read
			sequencer_trk_mgr_inst_trkm_readdata                         => sequencer_trk_mgr_inst_trkm_readdata,                      --                                                       .readdata
			sequencer_trk_mgr_inst_trkm_write                            => sequencer_trk_mgr_inst_trkm_write,                         --                                                       .write
			sequencer_trk_mgr_inst_trkm_writedata                        => sequencer_trk_mgr_inst_trkm_writedata,                     --                                                       .writedata
			trk_mm_bridge_m0_address                                     => trk_mm_bridge_m0_address,                                  --                                       trk_mm_bridge_m0.address
			trk_mm_bridge_m0_waitrequest                                 => trk_mm_bridge_m0_waitrequest,                              --                                                       .waitrequest
			trk_mm_bridge_m0_burstcount                                  => trk_mm_bridge_m0_burstcount,                               --                                                       .burstcount
			trk_mm_bridge_m0_byteenable                                  => trk_mm_bridge_m0_byteenable,                               --                                                       .byteenable
			trk_mm_bridge_m0_read                                        => trk_mm_bridge_m0_read,                                     --                                                       .read
			trk_mm_bridge_m0_readdata                                    => trk_mm_bridge_m0_readdata,                                 --                                                       .readdata
			trk_mm_bridge_m0_readdatavalid                               => trk_mm_bridge_m0_readdatavalid,                            --                                                       .readdatavalid
			trk_mm_bridge_m0_write                                       => trk_mm_bridge_m0_write,                                    --                                                       .write
			trk_mm_bridge_m0_writedata                                   => trk_mm_bridge_m0_writedata,                                --                                                       .writedata
			trk_mm_bridge_m0_debugaccess                                 => trk_mm_bridge_m0_debugaccess,                              --                                                       .debugaccess
			hphy_bridge_s0_address                                       => mm_interconnect_0_hphy_bridge_s0_address,                  --                                         hphy_bridge_s0.address
			hphy_bridge_s0_write                                         => mm_interconnect_0_hphy_bridge_s0_write,                    --                                                       .write
			hphy_bridge_s0_read                                          => mm_interconnect_0_hphy_bridge_s0_read,                     --                                                       .read
			hphy_bridge_s0_readdata                                      => mm_interconnect_0_hphy_bridge_s0_readdata,                 --                                                       .readdata
			hphy_bridge_s0_writedata                                     => mm_interconnect_0_hphy_bridge_s0_writedata,                --                                                       .writedata
			hphy_bridge_s0_waitrequest                                   => mm_interconnect_0_hphy_bridge_s0_waitrequest,              --                                                       .waitrequest
			sequencer_mem_s1_address                                     => mm_interconnect_0_sequencer_mem_s1_address,                --                                       sequencer_mem_s1.address
			sequencer_mem_s1_write                                       => mm_interconnect_0_sequencer_mem_s1_write,                  --                                                       .write
			sequencer_mem_s1_readdata                                    => mm_interconnect_0_sequencer_mem_s1_readdata,               --                                                       .readdata
			sequencer_mem_s1_writedata                                   => mm_interconnect_0_sequencer_mem_s1_writedata,              --                                                       .writedata
			sequencer_mem_s1_byteenable                                  => mm_interconnect_0_sequencer_mem_s1_byteenable,             --                                                       .byteenable
			sequencer_mem_s1_chipselect                                  => mm_interconnect_0_sequencer_mem_s1_chipselect,             --                                                       .chipselect
			sequencer_reg_file_inst_avl_address                          => mm_interconnect_0_sequencer_reg_file_inst_avl_address,     --                            sequencer_reg_file_inst_avl.address
			sequencer_reg_file_inst_avl_write                            => mm_interconnect_0_sequencer_reg_file_inst_avl_write,       --                                                       .write
			sequencer_reg_file_inst_avl_read                             => mm_interconnect_0_sequencer_reg_file_inst_avl_read,        --                                                       .read
			sequencer_reg_file_inst_avl_readdata                         => mm_interconnect_0_sequencer_reg_file_inst_avl_readdata,    --                                                       .readdata
			sequencer_reg_file_inst_avl_writedata                        => mm_interconnect_0_sequencer_reg_file_inst_avl_writedata,   --                                                       .writedata
			sequencer_reg_file_inst_avl_byteenable                       => mm_interconnect_0_sequencer_reg_file_inst_avl_byteenable,  --                                                       .byteenable
			sequencer_reg_file_inst_avl_waitrequest                      => mm_interconnect_0_sequencer_reg_file_inst_avl_waitrequest, --                                                       .waitrequest
			sequencer_scc_mgr_inst_avl_address                           => mm_interconnect_0_sequencer_scc_mgr_inst_avl_address,      --                             sequencer_scc_mgr_inst_avl.address
			sequencer_scc_mgr_inst_avl_write                             => mm_interconnect_0_sequencer_scc_mgr_inst_avl_write,        --                                                       .write
			sequencer_scc_mgr_inst_avl_read                              => mm_interconnect_0_sequencer_scc_mgr_inst_avl_read,         --                                                       .read
			sequencer_scc_mgr_inst_avl_readdata                          => mm_interconnect_0_sequencer_scc_mgr_inst_avl_readdata,     --                                                       .readdata
			sequencer_scc_mgr_inst_avl_writedata                         => mm_interconnect_0_sequencer_scc_mgr_inst_avl_writedata,    --                                                       .writedata
			sequencer_scc_mgr_inst_avl_waitrequest                       => mm_interconnect_0_sequencer_scc_mgr_inst_avl_waitrequest,  --                                                       .waitrequest
			sequencer_trk_mgr_inst_trks_address                          => mm_interconnect_0_sequencer_trk_mgr_inst_trks_address,     --                            sequencer_trk_mgr_inst_trks.address
			sequencer_trk_mgr_inst_trks_write                            => mm_interconnect_0_sequencer_trk_mgr_inst_trks_write,       --                                                       .write
			sequencer_trk_mgr_inst_trks_read                             => mm_interconnect_0_sequencer_trk_mgr_inst_trks_read,        --                                                       .read
			sequencer_trk_mgr_inst_trks_readdata                         => mm_interconnect_0_sequencer_trk_mgr_inst_trks_readdata,    --                                                       .readdata
			sequencer_trk_mgr_inst_trks_writedata                        => mm_interconnect_0_sequencer_trk_mgr_inst_trks_writedata,   --                                                       .writedata
			sequencer_trk_mgr_inst_trks_waitrequest                      => mm_interconnect_0_sequencer_trk_mgr_inst_trks_waitrequest, --                                                       .waitrequest
			trk_mm_bridge_s0_address                                     => mm_interconnect_0_trk_mm_bridge_s0_address,                --                                       trk_mm_bridge_s0.address
			trk_mm_bridge_s0_write                                       => mm_interconnect_0_trk_mm_bridge_s0_write,                  --                                                       .write
			trk_mm_bridge_s0_read                                        => mm_interconnect_0_trk_mm_bridge_s0_read,                   --                                                       .read
			trk_mm_bridge_s0_readdata                                    => mm_interconnect_0_trk_mm_bridge_s0_readdata,               --                                                       .readdata
			trk_mm_bridge_s0_writedata                                   => mm_interconnect_0_trk_mm_bridge_s0_writedata,              --                                                       .writedata
			trk_mm_bridge_s0_burstcount                                  => mm_interconnect_0_trk_mm_bridge_s0_burstcount,             --                                                       .burstcount
			trk_mm_bridge_s0_byteenable                                  => mm_interconnect_0_trk_mm_bridge_s0_byteenable,             --                                                       .byteenable
			trk_mm_bridge_s0_readdatavalid                               => mm_interconnect_0_trk_mm_bridge_s0_readdatavalid,          --                                                       .readdatavalid
			trk_mm_bridge_s0_waitrequest                                 => mm_interconnect_0_trk_mm_bridge_s0_waitrequest,            --                                                       .waitrequest
			trk_mm_bridge_s0_debugaccess                                 => mm_interconnect_0_trk_mm_bridge_s0_debugaccess             --                                                       .debugaccess
		);

	irq_mapper : component LPDDR2x32_s0_irq_mapper
		port map (
			clk        => avl_clk,                       --       clk.clk
			reset      => sequencer_rst_reset_out_reset, -- clk_reset.reset
			sender_irq => cpu_inst_d_irq_irq             --    sender.irq
		);

	sequencer_rst_reset_out_reset_ports_inv <= not sequencer_rst_reset_out_reset;

end architecture rtl; -- of LPDDR2x32_s0
