
# (C) 2001-2014 Altera Corporation. All rights reserved.
# Your use of Altera Corporation's design tools, logic functions and 
# other software and tools, and its AMPP partner logic functions, and 
# any output files any of the foregoing (including device programming 
# or simulation files), and any associated documentation or information 
# are expressly subject to the terms and conditions of the Altera 
# Program License Subscription Agreement, Altera MegaCore Function 
# License Agreement, or other applicable license agreement, including, 
# without limitation, that your use is for the sole purpose of 
# programming logic devices manufactured by Altera and sold by Altera 
# or its authorized distributors. Please refer to the applicable 
# agreement for further details.

# ACDS 14.0 200 win32 2014.09.06.13:00:20

# ----------------------------------------
# Auto-generated simulation script

# ----------------------------------------
# Initialize variables
if ![info exists SYSTEM_INSTANCE_NAME] { 
  set SYSTEM_INSTANCE_NAME ""
} elseif { ![ string match "" $SYSTEM_INSTANCE_NAME ] } { 
  set SYSTEM_INSTANCE_NAME "/$SYSTEM_INSTANCE_NAME"
}

if ![info exists TOP_LEVEL_NAME] { 
  set TOP_LEVEL_NAME "LPDDR2x32"
}

if ![info exists QSYS_SIMDIR] { 
  set QSYS_SIMDIR "./../"
}

if ![info exists QUARTUS_INSTALL_DIR] { 
  set QUARTUS_INSTALL_DIR "C:/altera/14.0/quartus/"
}

# ----------------------------------------
# Initialize simulation properties - DO NOT MODIFY!
set ELAB_OPTIONS ""
set SIM_OPTIONS ""
if ![ string match "*-64 vsim*" [ vsim -version ] ] {
} else {
}

# ----------------------------------------
# Copy ROM/RAM files to simulation directory
alias file_copy {
  echo "\[exec\] file_copy"
  file copy -force $QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_sequencer_mem.hex ./
  file copy -force $QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_AC_ROM.hex ./
  file copy -force $QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_inst_ROM.hex ./
}

# ----------------------------------------
# Create compilation libraries
proc ensure_lib { lib } { if ![file isdirectory $lib] { vlib $lib } }
ensure_lib          ./libraries/     
ensure_lib          ./libraries/work/
vmap       work     ./libraries/work/
vmap       work_lib ./libraries/work/
if ![ string match "*ModelSim ALTERA*" [ vsim -version ] ] {
  ensure_lib                       ./libraries/altera_ver/           
  vmap       altera_ver            ./libraries/altera_ver/           
  ensure_lib                       ./libraries/lpm_ver/              
  vmap       lpm_ver               ./libraries/lpm_ver/              
  ensure_lib                       ./libraries/sgate_ver/            
  vmap       sgate_ver             ./libraries/sgate_ver/            
  ensure_lib                       ./libraries/altera_mf_ver/        
  vmap       altera_mf_ver         ./libraries/altera_mf_ver/        
  ensure_lib                       ./libraries/altera_lnsim_ver/     
  vmap       altera_lnsim_ver      ./libraries/altera_lnsim_ver/     
  ensure_lib                       ./libraries/cyclonev_ver/         
  vmap       cyclonev_ver          ./libraries/cyclonev_ver/         
  ensure_lib                       ./libraries/cyclonev_hssi_ver/    
  vmap       cyclonev_hssi_ver     ./libraries/cyclonev_hssi_ver/    
  ensure_lib                       ./libraries/cyclonev_pcie_hip_ver/
  vmap       cyclonev_pcie_hip_ver ./libraries/cyclonev_pcie_hip_ver/
  ensure_lib                       ./libraries/altera/               
  vmap       altera                ./libraries/altera/               
  ensure_lib                       ./libraries/lpm/                  
  vmap       lpm                   ./libraries/lpm/                  
  ensure_lib                       ./libraries/sgate/                
  vmap       sgate                 ./libraries/sgate/                
  ensure_lib                       ./libraries/altera_mf/            
  vmap       altera_mf             ./libraries/altera_mf/            
  ensure_lib                       ./libraries/altera_lnsim/         
  vmap       altera_lnsim          ./libraries/altera_lnsim/         
  ensure_lib                       ./libraries/cyclonev/             
  vmap       cyclonev              ./libraries/cyclonev/             
}
ensure_lib                                  ./libraries/s0_seq_debug_translator/         
vmap       s0_seq_debug_translator          ./libraries/s0_seq_debug_translator/         
ensure_lib                                  ./libraries/dmaster_master_translator/       
vmap       dmaster_master_translator        ./libraries/dmaster_master_translator/       
ensure_lib                                  ./libraries/rst_controller/                  
vmap       rst_controller                   ./libraries/rst_controller/                  
ensure_lib                                  ./libraries/p2b_adapter/                     
vmap       p2b_adapter                      ./libraries/p2b_adapter/                     
ensure_lib                                  ./libraries/b2p_adapter/                     
vmap       b2p_adapter                      ./libraries/b2p_adapter/                     
ensure_lib                                  ./libraries/transacto/                       
vmap       transacto                        ./libraries/transacto/                       
ensure_lib                                  ./libraries/p2b/                             
vmap       p2b                              ./libraries/p2b/                             
ensure_lib                                  ./libraries/b2p/                             
vmap       b2p                              ./libraries/b2p/                             
ensure_lib                                  ./libraries/fifo/                            
vmap       fifo                             ./libraries/fifo/                            
ensure_lib                                  ./libraries/timing_adt/                      
vmap       timing_adt                       ./libraries/timing_adt/                      
ensure_lib                                  ./libraries/jtag_phy_embedded_in_jtag_master/
vmap       jtag_phy_embedded_in_jtag_master ./libraries/jtag_phy_embedded_in_jtag_master/
ensure_lib                                  ./libraries/mm_interconnect_1/               
vmap       mm_interconnect_1                ./libraries/mm_interconnect_1/               
ensure_lib                                  ./libraries/dll0/                            
vmap       dll0                             ./libraries/dll0/                            
ensure_lib                                  ./libraries/oct0/                            
vmap       oct0                             ./libraries/oct0/                            
ensure_lib                                  ./libraries/c0/                              
vmap       c0                               ./libraries/c0/                              
ensure_lib                                  ./libraries/dmaster/                         
vmap       dmaster                          ./libraries/dmaster/                         
ensure_lib                                  ./libraries/s0/                              
vmap       s0                               ./libraries/s0/                              
ensure_lib                                  ./libraries/p0/                              
vmap       p0                               ./libraries/p0/                              
ensure_lib                                  ./libraries/pll0/                            
vmap       pll0                             ./libraries/pll0/                            
ensure_lib                                  ./libraries/LPDDR2x32/                       
vmap       LPDDR2x32                        ./libraries/LPDDR2x32/                       

# ----------------------------------------
# Compile device library files
alias dev_com {
  echo "\[exec\] dev_com"
  if ![ string match "*ModelSim ALTERA*" [ vsim -version ] ] {
    vlog     "$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_primitives.v"                       -work altera_ver           
    vlog     "$QUARTUS_INSTALL_DIR/eda/sim_lib/220model.v"                                -work lpm_ver              
    vlog     "$QUARTUS_INSTALL_DIR/eda/sim_lib/sgate.v"                                   -work sgate_ver            
    vlog     "$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_mf.v"                               -work altera_mf_ver        
    vlog -sv "$QUARTUS_INSTALL_DIR/eda/sim_lib/mentor/altera_lnsim_for_vhdl.sv"           -work altera_lnsim_ver     
    vlog     "$QUARTUS_INSTALL_DIR/eda/sim_lib/mentor/cyclonev_atoms_ncrypt.v"            -work cyclonev_ver         
    vlog     "$QUARTUS_INSTALL_DIR/eda/sim_lib/mentor/cyclonev_hmi_atoms_ncrypt.v"        -work cyclonev_ver         
    vlog     "$QUARTUS_INSTALL_DIR/eda/sim_lib/mentor/cyclonev_atoms_for_vhdl.v"          -work cyclonev_ver         
    vlog     "$QUARTUS_INSTALL_DIR/eda/sim_lib/mentor/cyclonev_hssi_atoms_ncrypt.v"       -work cyclonev_hssi_ver    
    vlog     "$QUARTUS_INSTALL_DIR/eda/sim_lib/mentor/cyclonev_hssi_atoms_for_vhdl.v"     -work cyclonev_hssi_ver    
    vlog     "$QUARTUS_INSTALL_DIR/eda/sim_lib/mentor/cyclonev_pcie_hip_atoms_ncrypt.v"   -work cyclonev_pcie_hip_ver
    vlog     "$QUARTUS_INSTALL_DIR/eda/sim_lib/mentor/cyclonev_pcie_hip_atoms_for_vhdl.v" -work cyclonev_pcie_hip_ver
    vcom     "$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_syn_attributes.vhd"                 -work altera               
    vcom     "$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_standard_functions.vhd"             -work altera               
    vcom     "$QUARTUS_INSTALL_DIR/eda/sim_lib/alt_dspbuilder_package.vhd"                -work altera               
    vcom     "$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_europa_support_lib.vhd"             -work altera               
    vcom     "$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_primitives_components.vhd"          -work altera               
    vcom     "$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_primitives.vhd"                     -work altera               
    vcom     "$QUARTUS_INSTALL_DIR/eda/sim_lib/220pack.vhd"                               -work lpm                  
    vcom     "$QUARTUS_INSTALL_DIR/eda/sim_lib/220model.vhd"                              -work lpm                  
    vcom     "$QUARTUS_INSTALL_DIR/eda/sim_lib/sgate_pack.vhd"                            -work sgate                
    vcom     "$QUARTUS_INSTALL_DIR/eda/sim_lib/sgate.vhd"                                 -work sgate                
    vcom     "$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_mf_components.vhd"                  -work altera_mf            
    vcom     "$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_mf.vhd"                             -work altera_mf            
    vcom     "$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_lnsim_components.vhd"               -work altera_lnsim         
    vcom     "$QUARTUS_INSTALL_DIR/eda/sim_lib/cyclonev_atoms.vhd"                        -work cyclonev             
    vcom     "$QUARTUS_INSTALL_DIR/eda/sim_lib/cyclonev_components.vhd"                   -work cyclonev             
  }
}

# ----------------------------------------
# Compile the design files in correct order
alias com {
  echo "\[exec\] com"
  vlog -sv "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_merlin_slave_translator.sv"                                  -work s0_seq_debug_translator         
  vlog -sv "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_merlin_master_translator.sv"                                 -work dmaster_master_translator       
  vlog     "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_reset_controller.v"                                          -work rst_controller                  
  vlog     "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_reset_synchronizer.v"                                        -work rst_controller                  
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_dmaster_p2b_adapter.vho"                                         -work p2b_adapter                     
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_dmaster_b2p_adapter.vho"                                         -work b2p_adapter                     
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_dmaster_transacto.vho"                                           -work transacto                       
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_dmaster_p2b.vho"                                                 -work p2b                             
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_dmaster_b2p.vho"                                                 -work b2p                             
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_dmaster_fifo.vho"                                                -work fifo                            
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_dmaster_timing_adt.vho"                                          -work timing_adt                      
  vlog     "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_avalon_st_jtag_interface.v"                                  -work jtag_phy_embedded_in_jtag_master
  vlog     "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_jtag_dc_streaming.v"                                         -work jtag_phy_embedded_in_jtag_master
  vlog     "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_jtag_sld_node.v"                                             -work jtag_phy_embedded_in_jtag_master
  vlog     "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_jtag_streaming.v"                                            -work jtag_phy_embedded_in_jtag_master
  vlog     "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_pli_streaming.v"                                             -work jtag_phy_embedded_in_jtag_master
  vlog     "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_avalon_st_clock_crosser.v"                                   -work jtag_phy_embedded_in_jtag_master
  vlog     "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_avalon_st_pipeline_base.v"                                   -work jtag_phy_embedded_in_jtag_master
  vlog     "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_avalon_st_idle_remover.v"                                    -work jtag_phy_embedded_in_jtag_master
  vlog     "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_avalon_st_idle_inserter.v"                                   -work jtag_phy_embedded_in_jtag_master
  vlog -sv "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_avalon_st_pipeline_stage.sv"                                 -work jtag_phy_embedded_in_jtag_master
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_mm_interconnect_1.vhd"                                           -work mm_interconnect_1               
  vlog -sv "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_mem_if_dll_cyclonev.sv"                                      -work dll0                            
  vlog -sv "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_mem_if_oct_cyclonev.sv"                                      -work oct0                            
  vlog -sv "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_mem_if_hard_memory_controller_top_cyclonev.sv"               -work c0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_dmaster.vhd"                                                     -work dmaster                         
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0.vhd"                                                          -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_irq_mapper.vho"                                               -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_mm_interconnect_0.vhd"                                        -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_mm_interconnect_0_cmd_demux.vho"                              -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_mm_interconnect_0_cmd_demux_001.vho"                          -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_mm_interconnect_0_cmd_demux_002.vho"                          -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_mm_interconnect_0_cmd_demux_004.vho"                          -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_mm_interconnect_0_cmd_mux.vho"                                -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_mm_interconnect_0_cmd_mux_002.vho"                            -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_mm_interconnect_0_cmd_mux_003.vho"                            -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/lpddr2x32_s0_mm_interconnect_0_cpu_inst_data_master_translator.vhd"        -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/lpddr2x32_s0_mm_interconnect_0_cpu_inst_instruction_master_translator.vhd" -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/lpddr2x32_s0_mm_interconnect_0_hphy_bridge_s0_translator.vhd"              -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_mm_interconnect_0_router.vho"                                 -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_mm_interconnect_0_router_001.vho"                             -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_mm_interconnect_0_router_002.vho"                             -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_mm_interconnect_0_router_003.vho"                             -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_mm_interconnect_0_router_004.vho"                             -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_mm_interconnect_0_router_005.vho"                             -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_mm_interconnect_0_router_007.vho"                             -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_mm_interconnect_0_router_008.vho"                             -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_mm_interconnect_0_router_009.vho"                             -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_mm_interconnect_0_router_010.vho"                             -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_mm_interconnect_0_rsp_demux_002.vho"                          -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_mm_interconnect_0_rsp_mux.vho"                                -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_mm_interconnect_0_rsp_mux_001.vho"                            -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_mm_interconnect_0_rsp_mux_002.vho"                            -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/lpddr2x32_s0_mm_interconnect_0_sequencer_mem_s1_translator.vhd"            -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/lpddr2x32_s0_mm_interconnect_0_sequencer_reg_file_inst_avl_translator.vhd" -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/lpddr2x32_s0_mm_interconnect_0_sequencer_scc_mgr_inst_avl_translator.vhd"  -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/lpddr2x32_s0_mm_interconnect_0_sequencer_trk_mgr_inst_trkm_translator.vhd" -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/lpddr2x32_s0_mm_interconnect_0_sequencer_trk_mgr_inst_trks_translator.vhd" -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/lpddr2x32_s0_mm_interconnect_0_seq_bridge_m0_translator.vhd"               -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/lpddr2x32_s0_mm_interconnect_0_trk_mm_bridge_m0_translator.vhd"            -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_mm_interconnect_0_trk_mm_bridge_s0_agent_rsp_fifo.vho"        -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/lpddr2x32_s0_mm_interconnect_0_trk_mm_bridge_s0_translator.vhd"            -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_seq_bridge.vho"                                               -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_s0_trk_mm_bridge.vho"                                            -work s0                              
  vlog     "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_mem_if_sequencer_cpu_cv_sim_cpu_inst.v"                      -work s0                              
  vlog     "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_mem_if_sequencer_cpu_cv_sim_cpu_inst_test_bench.v"           -work s0                              
  vlog -sv "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_mem_if_sequencer_mem_no_ifdef_params.sv"                     -work s0                              
  vlog -sv "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_mem_if_sequencer_rst.sv"                                     -work s0                              
  vlog -sv "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_mem_if_simple_avalon_mm_bridge.sv"                           -work s0                              
  vlog -sv "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_merlin_burst_uncompressor.sv"                                -work s0                              
  vlog -sv "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_merlin_master_agent.sv"                                      -work s0                              
  vlog -sv "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_merlin_slave_agent.sv"                                       -work s0                              
  vlog -sv "$QSYS_SIMDIR/LPDDR2x32/mentor/altera_merlin_traffic_limiter.sv"                                   -work s0                              
  vlog -sv "$QSYS_SIMDIR/LPDDR2x32/mentor/sequencer_reg_file.sv"                                              -work s0                              
  vlog     "$QSYS_SIMDIR/LPDDR2x32/mentor/sequencer_scc_acv_phase_decode.v"                                   -work s0                              
  vlog -sv "$QSYS_SIMDIR/LPDDR2x32/mentor/sequencer_scc_acv_wrapper.sv"                                       -work s0                              
  vlog -sv "$QSYS_SIMDIR/LPDDR2x32/mentor/sequencer_scc_mgr.sv"                                               -work s0                              
  vlog     "$QSYS_SIMDIR/LPDDR2x32/mentor/sequencer_scc_reg_file.v"                                           -work s0                              
  vlog     "$QSYS_SIMDIR/LPDDR2x32/mentor/sequencer_scc_siii_phase_decode.v"                                  -work s0                              
  vlog -sv "$QSYS_SIMDIR/LPDDR2x32/mentor/sequencer_scc_siii_wrapper.sv"                                      -work s0                              
  vlog     "$QSYS_SIMDIR/LPDDR2x32/mentor/sequencer_scc_sv_phase_decode.v"                                    -work s0                              
  vlog -sv "$QSYS_SIMDIR/LPDDR2x32/mentor/sequencer_scc_sv_wrapper.sv"                                        -work s0                              
  vlog -sv "$QSYS_SIMDIR/LPDDR2x32/mentor/sequencer_trk_mgr.sv"                                               -work s0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_p0.vho"                                                          -work p0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_p0_altdqdqs.vhd"                                                 -work p0                              
  vlog -sv "$QSYS_SIMDIR/LPDDR2x32/mentor/altdq_dqs2_acv_connect_to_hard_phy_cyclonev_lpddr2.sv"              -work p0                              
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_pll0.vho"                                                        -work pll0                            
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_pll0_sim_delay.vhd"                                              -work pll0                            
  vcom     "$QSYS_SIMDIR/LPDDR2x32/LPDDR2x32_0002.vhd"                                                        -work LPDDR2x32                       
  vcom     "$QSYS_SIMDIR/LPDDR2x32.vhd"                                                                                                             
}

# ----------------------------------------
# Elaborate top level design
alias elab {
  echo "\[exec\] elab"
  eval vsim -t ps $ELAB_OPTIONS -L work -L work_lib -L s0_seq_debug_translator -L dmaster_master_translator -L rst_controller -L p2b_adapter -L b2p_adapter -L transacto -L p2b -L b2p -L fifo -L timing_adt -L jtag_phy_embedded_in_jtag_master -L mm_interconnect_1 -L dll0 -L oct0 -L c0 -L dmaster -L s0 -L p0 -L pll0 -L LPDDR2x32 -L altera_ver -L lpm_ver -L sgate_ver -L altera_mf_ver -L altera_lnsim_ver -L cyclonev_ver -L cyclonev_hssi_ver -L cyclonev_pcie_hip_ver -L altera -L lpm -L sgate -L altera_mf -L altera_lnsim -L cyclonev $TOP_LEVEL_NAME
}

# ----------------------------------------
# Elaborate the top level design with novopt option
alias elab_debug {
  echo "\[exec\] elab_debug"
  eval vsim -novopt -t ps $ELAB_OPTIONS -L work -L work_lib -L s0_seq_debug_translator -L dmaster_master_translator -L rst_controller -L p2b_adapter -L b2p_adapter -L transacto -L p2b -L b2p -L fifo -L timing_adt -L jtag_phy_embedded_in_jtag_master -L mm_interconnect_1 -L dll0 -L oct0 -L c0 -L dmaster -L s0 -L p0 -L pll0 -L LPDDR2x32 -L altera_ver -L lpm_ver -L sgate_ver -L altera_mf_ver -L altera_lnsim_ver -L cyclonev_ver -L cyclonev_hssi_ver -L cyclonev_pcie_hip_ver -L altera -L lpm -L sgate -L altera_mf -L altera_lnsim -L cyclonev $TOP_LEVEL_NAME
}

# ----------------------------------------
# Compile all the design files and elaborate the top level design
alias ld "
  dev_com
  com
  elab
"

# ----------------------------------------
# Compile all the design files and elaborate the top level design with -novopt
alias ld_debug "
  dev_com
  com
  elab_debug
"

# ----------------------------------------
# Print out user commmand line aliases
alias h {
  echo "List Of Command Line Aliases"
  echo
  echo "file_copy                     -- Copy ROM/RAM files to simulation directory"
  echo
  echo "dev_com                       -- Compile device library files"
  echo
  echo "com                           -- Compile the design files in correct order"
  echo
  echo "elab                          -- Elaborate top level design"
  echo
  echo "elab_debug                    -- Elaborate the top level design with novopt option"
  echo
  echo "ld                            -- Compile all the design files and elaborate the top level design"
  echo
  echo "ld_debug                      -- Compile all the design files and elaborate the top level design with -novopt"
  echo
  echo 
  echo
  echo "List Of Variables"
  echo
  echo "TOP_LEVEL_NAME                -- Top level module name."
  echo
  echo "SYSTEM_INSTANCE_NAME          -- Instantiated system module name inside top level module."
  echo
  echo "QSYS_SIMDIR                   -- Qsys base simulation directory."
  echo
  echo "QUARTUS_INSTALL_DIR           -- Quartus installation directory."
}
file_copy
h
